import pandas as pd


def extend_categories(categories: str):
    if categories:
        ext_categories = []
        for category_path in categories.split(';'):
            categories = category_path.split('/')
            for i in range(1, len(categories) + 1):
                path = '/'.join(categories[:i])
                if path not in ext_categories:
                    ext_categories.append(path)

        return ';'.join(ext_categories)


df = pd.read_csv("products.csv", encoding='utf-8', dtype=str)
ext_category = df['Category'].fillna('').map(extend_categories)
col_position = df.columns.get_loc('Category')
df.insert(col_position + 1, 'ExtendedCategory', ext_category)

df.to_csv("modified_products.csv", index=False, encoding='utf-8')
print('Done!')
